#include "knn.h"
# include <math.h>
Knn::Knn(int myk,Dataset *train,Dataset *test)
{
    K=1;
    setK(myk);
    trainSet=train;
    testSet=test;
}

int     Knn::getK()
{
    return K;
}

void    Knn::setK(int myk)
{
    if(myk>0)
    K=myk;
}

double  Knn::getDistance(Data pattern1,Data pattern2)
{
    int i;
    double sum=0.0;
    for(i=0;i<pattern1.size();i++)
    {
        sum+=(pattern1[i]-pattern2[i])*(pattern1[i]-pattern2[i]);
    }
    return sqrt(sum);
}

double  Knn::getClass(Data pattern)
{
   Data  distances;
   Data  position;
   int i,j;
   for(i=0;i<trainSet->getpatterns();i++)
   {
        double d=getDistance(pattern,trainSet->getpoint(i));
        distances<<d;
        position<<i;
   }
   //sorting
   for(i=0;i<distances.size();i++)
   {
       for(j=0;j<distances.size()-1;j++)
       {
           if(distances[j+1]<distances[j])
           {
               double dtemp=distances[j];
               distances[j]=distances[j+1];
               distances[j+1]=dtemp;
               int itemp=position[j];
               position[j]=position[j+1];
               position[j+1]=itemp;
           }
       }
   }
   //find best class
   Data findClass;
   QVector<int> votes;
   for(i=0;i<K;i++)
   {
       double yclass=trainSet->gety(position[i]);
       int foundPosition=-1;
       for(j=0;j<findClass.size();j++)
       {
            if(fabs(yclass-findClass[j])<1e-5)
            {
                foundPosition=j;
                break;
            }
       }
       if(foundPosition!=-1)
       {
           votes[foundPosition]++;
       }
       else
       {
           findClass<<yclass;
           votes<<1;
       }
   }
   //maximum class in findclass
   double maxClass=findClass[0];
   int maxVotes=votes[0];
   for(i=0;i<findClass.size();i++)
   {
       if(votes[i]>maxVotes)
       {
           maxVotes=votes[i];
           maxClass=findClass[i];
       }
   }
   return maxClass;
}

double  Knn::getTestError()
{
    int missed=0;
    int i;
    for(i=0;i<testSet->getpatterns();i++)
    {
        double estClass=getClass(testSet->getpoint(i));
        double realClass=testSet->gety(i);
        if(fabs(estClass-realClass)>1e-5) missed++;
    }
    return missed*100.0/testSet->getpatterns();
}
